/*** MG estimation ***/


proc(11)=mg(yname,xname,y,x,n,tivec,starttvec,endtvec,years);
local namevar,cumtivec,x_mg,k,ttest05,ttest10,ttest20,i,y_i,x_i,b_i,e_i,inverse_x_x,sig_i,sig2_i;
local b_vec,sig_vec,startyear,endyear,cov_b_i,se_b_i,tvalue_b_i,e;
local estvec,mean,medi,sd,m2,m3,m4,skew,kurtosis,resultvec,out_mg;
local namev,statsname,string_resultvec,varnames, varnames2,ytoy;
local b_mg,b_dm,sig_mg,sig2_mg,cov_mg,se_mg,tvalue_mg,nameh,results_mg;
local st_results_mg,e_mg;
local mgexcel,st_st,testname,testi,testst,c,t_vec,t_vec_homo,sighomo;

namevar=yname|xname;
cumtivec=0|cumsumc(tivec);
x_mg=x/*~ones(rows(x),1)*/;
k=cols(x_mg);
t_vec=zeros(n,k);t_vec_homo=zeros(n,k);
inverse_x_x=zeros(cols(x_mg),cols(x_mg));
ttest05=zeros(1,k);
ttest10=zeros(1,k);
ttest20=zeros(1,k);
	i=1;
	do while i<=n;
		y_i=y[cumtivec[i]+1:cumtivec[i+1]];
		x_i=x_mg[cumtivec[i]+1:cumtivec[i+1],1:cols(x_mg)];
		b_i=pinv(x_i'x_i)*x_i'y_i;
		e_i=y_i-x_i*b_i;
		inverse_x_x = inverse_x_x + pinv(x_i'x_i); /*** For Hausman test 1 ***/
        sig_i=sqrt(e_i'e_i/(tivec[i]-k));
		sig2_i=sig_i^2;
			if i==1;
				b_vec=b_i';
				sig_vec=sig_i;
				e = y_i-x_i*b_i;
				startyear=years[starttvec[i]];
				endyear=years[endtvec[i]];
					else;
						b_vec=b_vec|(b_i');
						e = e|(y_i-x_i*b_i);
						sig_vec=sig_vec|sig_i;
						startyear=startyear|years[starttvec[i]];
						endyear=endyear|years[endtvec[i]];
			endif;
        e_mg=e;
		/*** t-test for each i ***/
			cov_b_i=sig2_i*pinv(x_i'x_i);
			se_b_i=sqrt(diag(cov_b_i));
			tvalue_b_i=abs(b_i./se_b_i); /** absolute t-value **/
            t_vec[i,.]=(b_i')./(se_b_i');
			/** 5% test **/
			ttest05=ttest05 + (cdftc(tvalue_b_i',tivec[i]-k).<(0.05/2)); /* two sided*/
			ttest10=ttest10 + (cdftc(tvalue_b_i',tivec[i]-k).<(0.1/2));   /* two sided*/
			ttest20=ttest20 + (cdftc(tvalue_b_i',tivec[i]-k).<(0.2/2));   /* two sided*/
			
			
		i=i+1;
	endo;

/*t_vec_homo*/
sighomo=e_mg'e_mg/(sumc(tivec)-n*k);"sighomo:";;sighomo;
	i=1;
	do while i<=n;
		x_i=x_mg[cumtivec[i]+1:cumtivec[i+1],1:cols(x_mg)];
            t_vec_homo[i,.]=(b_vec[i,.])./sqrt(diag(sighomo*pinv(x_i'x_i)))';
		i=i+1;
	endo;


estvec=b_vec~sig_vec~tivec;
mean=meanc(estvec)';
medi=median(estvec)';
sd=stdc(estvec)'; /* sqrt{[sum(Rt-Rbar)^2]/N-1} */
	m2=meanc((estvec-mean).^2)';
	m3=meanc((estvec-mean).^3)';
	m4=meanc((estvec-mean).^4)';
skew=m3./(sqrt(m2).^3);
kurtosis=m4./(m2.^2);
resultvec=estvec|mean|medi|sd|skew|kurtosis;


 format /rd 11,7;

namev=ftocv(seqa(1,1,n),2,0);
statsname={"mean","median","s.d.","skewness","kurtosis"};
namev=namev|statsname;
string_resultvec=ftocv(resultvec,8,8);
	varnames=(namevar')~"sig_i"~"Ti";

	varnames2="Start"~"end";
	ytoy=varnames2|(startyear~endyear)|zeros(5,2)*"";
		

/** mg estimator **/
b_mg=mean[1:k]';/** col vec**/
b_dm=(b_vec-b_mg');    /** row vec**/
sig_mg=mean[k+1];
sig2_mg=sig_mg^2;
cov_mg=b_dm'b_dm/(n*(n-1));
se_mg=sqrt(diag(cov_mg));
tvalue_mg=b_mg./se_mg;

/* output*/
results_mg=b_mg~se_mg~tvalue_mg;
st_results_mg=ftocv(results_mg,7,7);
nameh="coeff"~"se"~"t-value";

out_mg = namevar~(nameh|st_results_mg);

MGexcel= (varnames|(namev~string_resultvec))~ytoy;
st_st=ftocv((se_mg~tvalue_mg)',7,7);
testname="se"|"tvalue"|"t(i)5%"|"t(i)10%"|"t(i)20%";

c=ftocv(((ttest05|ttest10|ttest20)/n)*100,1,1);
testi=0 $+ c $+ "%";
testst = testname~(st_st|testi);

MGexcel=mgexcel|(testst~zeros(rows(testst),cols(mgexcel)-k-1));

retp(b_mg,cov_mg,sig_mg,e_mg,inverse_x_x,out_mg,mgexcel,b_vec,sig_vec,t_vec,t_vec_homo);
endp;